import numpy as np
from cvxopt import matrix, solvers


def stackelberg(u1, u2):
    '''
    Compute the optimal Stackelberg strategy for the given 2-player normal form game.
        
    Arguments:
        u1: a list of lists representing the utility function for player 1
        u2: a list of lists representing the utility function for player 2
        
    Return:
        (u,x1,s2) where
            u is the expected utility for player 1 of mixed strategy x1 and s2
            x1 is a list of probabilities representing the mixed strategy of player 1
            s2 is the index (0-based) of the pure strategy for player 2
    '''
    pass
